//*************************************************************************************
// 	: SQ7613_SPI_Flash_IS25LP080D.h
// 汾		: V1.0
// 		: SPI_Flash_IS25LP080Dͷļ
// ע		: 
//**************************************************************************************
#ifndef _SQ7613_SPI_Flash_IS25LP080D_H__
#define _SQ7613_SPI_Flash_IS25LP080D_H__

/* ---------------------- extern ȫֱ ------------------------- */
extern unsigned char Status_Data;



/* ---------------------- Զ ------------------------------ */
#define IS25LP_RDMDID   0x90    // Read Manufacturer ID & Device ID
#define IS25LP_RDID	    0xAB    // Read Device ID
#define IS25LP_WRSR	    0x01    // Write Status Register
#define IS25LP_Write    0x02    // Page Program (PP)
#define IS25LP_Read	    0x03    // Read Data Bytes from Memory at Normal Read Mode
#define IS25LP_WRDIS    0x04    // Write Disable
#define IS25LP_RDSR	    0x05    // Read Status Register
#define IS25LP_WREN	    0x06    // Write Enable
#define IS25LP_Erase4K	0x20    // Sector Erase 4Kbyte (SER)

//-----------------------------------------------------------------
void IS25LP_WaitBusy(void);
void IS25LP_Write_Enable(void);
void IS25LP_Write_Disable(void);

#endif


