//*************************************************************************************
// 	: SQ7613_TCA0_16BIT_Timer.c
// 汾		: V1.1
// 		: TCA0_16BIT_Timer ʹú
// ע		: TCA0_16BIT_Timer غ㼯ڱӳ [Only TCA0_Timer]
//**************************************************************************************
#include "main.h"

unsigned char TCA0_Int_Flag;				  // TCA0жϷ

//*********************************************************************
// 	: TCA0_Timer_Init()
// 	: TCA0 ʱģʽʼ
// ע		: 
//*********************************************************************
void TCA0_Timer_Init(){
//====== ܿ( Enable) ======
	PCKEN0_TCA0 = 1;                    	  // TCA0 Enable
	
//====== 趨 ======
	TA0MOD_TAM = 0x00;                  	  // 趨TCA0Ϊ 16 λʱģʽ
	TA0MOD_TADBE    = 1;                	  // ʹ˫
	
	// ϵͳƵΪ24MHz,TCA0ʱ֮ʱƵΪ23.437kHz
    TA0MOD_TACK     = 0x00;                	  // ʱTCA0 Դʱӣfcgck/(2^10) = 24M/1024 Hz = 23.437kHz => 42.6667us
	//TA0MOD_TACK     = 0x01;                 // ʱTCA0 Դʱӣfcgck/(2^6)
	//TA0MOD_TACK     = 0x02;                 // ʱTCA0 Դʱӣfcgck/(2^2)
	//TA0MOD_TACK     = 0x03;                 // ʱTCA0 Դʱӣfcgck/(2^1)

}


//*********************************************************************
// 	: TCA0_IntEnable()
// 	: STCA0ж
// ע		: 
//*********************************************************************
void TCA0_IntEnable(){
	__ASM("DI");							  // ֹпж
	
	IER_TCA0 = 1;                       	  // 趨TCA0ж
	//TA0CR_TAOVE = 0;                    	  // TCA0λжϷʱжҪ
	TA0CR_TAOVE = 1;                    	  // TCA0λжϷʱжҪ
	
	__ASM("EI");							  // пж
}


//*********************************************************************
// 	: TCA0_SetPeriod()
// 	: 趨TCA0
// ע		: 
//*********************************************************************
void TCA0_SetPeriod(unsigned int period){
	
 	TA0DRAL = period&0xFF;              	  // 趨TCA0
 	TA0DRAH = (period>>8)&0xFF;
	//TA0DRA = period;

}


//*********************************************************************
// 	: TCA0_Start()
// 	: TCA0,ʼ
// ע		: 
//*********************************************************************
void TCA0_Start(){
	
	TA0CR_TAS = 1;                      	  // TCA0ʼ

}


//*********************************************************************
// 	: TCA0_Stop()
// 	: TCA0ֹͣ
// ע		: 
//*********************************************************************
void TCA0_Stop(){
	
	TA0CR_TAS = 0;                      	  // TCA0ֹͣ

}



//*********************************************************************
// 	: __interrupt IntTCA0()
// 	: TCA0 жӳ
// ע		:
//*********************************************************************
void __interrupt IntTCA0(void){
	__asm("NOP");							  // ָ

	TCA0_Int_Flag = 1;						  // TCA0жϷ趨Ϊ1
}

