//*************************************************************************************
// 	: SQ7613_TCA.c
// 汾		: V1.2
// 		: TCA ʹú
// ע		: TCA غ㼯ڱӳ
//**************************************************************************************
#include "main.h"

unsigned int  captch_count;
unsigned char TCA0_Int_Flag;				  // TCA0жϷ
unsigned char TCA1_Int_Flag;				  // TCA1жϷ/unsigned char TCA5_Int_Flag;				  // TCA5жϷ


//*********************************************************************
// 	: TCA0_Timer_Init()
// 	: TCA0 ʱģʽʼ
// ע		: 
//*********************************************************************
void TCA0_Timer_Init(){
//====== ܿ( Enable) ======
	PCKEN0_TCA0 = 1;                    	  // TCA0 Enable
	
//====== 趨 ======
	TA0MOD_TAM = 0x00;                  	  // 趨TCA0Ϊ 16 λʱģʽ
	TA0MOD_TADBE = 1;                	  	  // ʹ˫
	
	// ϵͳƵΪ24MHz,TCA0ʱ֮ʱƵΪ23.437kHz
    TA0MOD_TACK   = 0x00;                	  // ʱTCA0 Դʱӣfcgck/(2^10) = 24M/1024 Hz = 23.437kHz => 42.6667us
}


//*********************************************************************
// 	: TCA0_IntEnable()
// 	: STCA0ж
// ע		: 
//*********************************************************************
void TCA0_IntEnable(){
	__ASM("DI");							  // ֹпж
	
	IER_TCA0 = 1;                       	  // 趨TCA0ж
	//TA0CR_TAOVE = 0;                    	  // TCA0λжϷʱжҪ
	TA0CR_TAOVE = 1;                    	  // TCA0λжϷʱжҪ
	
	__ASM("EI");							  // пж
}


//*********************************************************************
// 	: TCA0_SetPeriod()
// 	: 趨TCA0
// ע		: 
//*********************************************************************
void TCA0_SetPeriod(unsigned int period){
	
 	TA0DRAL  = period&0xFF;              	  // 趨TCA0
 	TA0DRAH  = (period>>8)&0xFF;
	//TA0DRA = period;

}


//*********************************************************************
// 	: TCA0_Start()
// 	: TCA0,ʼ
// ע		: 
//*********************************************************************
void TCA0_Start(){
	
	TA0CR_TAS = 1;                      	  // TCA0ʼ

}


//*********************************************************************
// 	: TCA0_Stop()
// 	: TCA0ֹͣ
// ע		: 
//*********************************************************************
void TCA0_Stop(){
	
	TA0CR_TAS = 0;                      	  // TCA0ֹͣ

}


//*********************************************************************
// 	: TCA1_PulseMeasure_Init()
// 	: TCA1ģʽʼ
// ע		: 
//*********************************************************************
void TCA1_PulseMeasure_Init(){
//====== ܽųʼ ======


//---Ѷ֮ܽ趨(P0.1)--- 
	FSELR0 = (FSELR0&0xF0)|0x05;              // 趨ѡĴ0
	PCSELR4_TCA1 = 0x00;              		  // TCA1ѡP0.1
    
	P0FC1_P1 = 1;                       	  // P0.1OTCA1
	P0FC2_P1 = 0;


/*
//---Ѷ֮ܽ趨(P2.1)---	
	FSELR2 = (FSELR2&0xF0)|0x05;              // 趨ѡĴ2
	PCSELR4_TCAPC1 = 0x01;              	  // TCA1ѡP2.1
    
	P2FC1_P1 = 1;                       	  // P2.1OTCA1
	P2FC2_P1 = 0;
*/


//====== ܿ( Enable) ======
	PCKEN0_TCA1 = 1;                    	  // TCA1 Enable
	
//====== 趨 ======	
	TA1MOD_TAM = 0x06;                  	  // 趨TCA1Ϊģʽ
	
	// ϵͳƵΪ24MHz,TCA1֮ƵΪ23.437kHz
    TA1MOD_TACK   = 0x00;                	  // ʱTCA1 Դʱӣfcgck/(2^10) = 24M/1024 Hz = 23.437kHz => 42.6667us
	
	TA1MOD_TAMCAP = 0;                	  	  // ˫ץȡ
	//TA1MOD_TAMCAP = 1;                	  // ץȡ
	
	//TA1MOD_TATED  = 0;                   	  // ش
	TA1MOD_TATED    = 1;                   	  // ½ش

}



//*********************************************************************
// 	: TCA1_IntEnable()
// 	: STCA1ж
// ע		: 
//*********************************************************************
void TCA1_IntEnable(){
	__ASM("DI");							  // ֹпж
	
	IER_TCA1 = 1;                       	  // 趨TCA1ж
	//TA0CR_TAOVE = 0;                    	  // TCA1λжϷʱжҪ
	TA1CR_TAOVE   = 1;                    	  // TCA1λжϷʱжҪ
	
	__ASM("EI");							  // пж
}



//*********************************************************************
// 	: TCA1_Start()
// 	: TCA1ʼ
// ע		: 
//*********************************************************************
void TCA1_Start(){
	
	TA1CR_TAS = 1;                      	  // TCA1ʼ
	
}



//*********************************************************************
// 	: TCA1_Stop()
// 	: TCA1ֹͣ
// ע		: 
//*********************************************************************
void TCA1_Stop(){
	
	TA1CR_TAS = 0;                      	  // TCA1ֹͣ
	
}



//*********************************************************************
// 	: TCA1_ReadSingleCapture()
// 	: ȡֵ 
// ע		: *ģʽ
//*********************************************************************
unsigned int TCA1_ReadSingleCapture(){

    return *(unsigned int*)&TA1DRBL;    	  // ȡTCA1ֵ
	//return TA1DRB;    	  			      // ȡTCA1ֵ
}



//*********************************************************************
//    : TCA1_ReadDoubleCapture()
// 	: ȡ 
// ע     : *˫ץȡģʽ
//*********************************************************************
unsigned int TCA1_ReadDoubleCapture()
{
	return *(unsigned int*)&TA1DRAL;    	  // ȡTCA1ڼֵ
    //return TA1DRA;						  // ȡTCA1ڼֵ
}



//*********************************************************************
//    : TCA5_PPG_Init()
//  : ɱPPGʼ
// ע     : ɱPPG  1 ms ռձ 50%
//*********************************************************************
void TCA5_PPG_Init()
{
//====== ܽųʼ ======


//---ɱܽ趨(P0.5)--- // [ʹô]
	FSELR0 = (FSELR0&0x0F)|0x50;			  // 趨ѡĴ0
	PCSELR5_TCA5 = 0x00;              		  // TCA5ѡP0.5
    
	P0FC1_P5 = 1;                       	  // P0.5OTCA5
	P0FC2_P5 = 0;



/*	
//---ɱܽ趨(P2.5)---
	FSELR2 = (FSELR2&0x0F)|0x50;			  // 趨ѡĴ2
	PCSELR5_TCA5 = 0x01;              		  // TCA5ѡP2.5
	
	P2FC1_P5 = 1;                       	  // P2.5OTCA5
	P2FC2_P5 = 0;
*/

	
//====== ܿ( Enable) ======
	PCKEN1_TCA5 = 1;                    	  // TCA5 Enable


//====== 趨 ======
	TA5MOD_TAM     = 0x03;              	  // 趨Ϊ 16 λɱ PPG ģʽ
    TA5CR_TATFF    = 1;                 	  // 趨ʼֵΪ"׼λ"ռձ
	
	TA5CR_TAMPPG   = 0; 					  // PPG 
    //TA5CR_TAMPPG = 1;                 	  // PPG 
	
	// ϵͳƵΪ8MHz,TCA5֮ƵΪHz
    TA5MOD_TADBE   = 1;                 	  // ʹ˫
    TA5MOD_TACK    = 0x02;              	  // fcgck/(4) = 4M/4 = 1MHz => λʱ1us
    TA5DRA         = 10000;             	  // 趨 PPG  = 10000 * 1us = 10ms
    TA5DRB         = 6500;              	  // 趨 PPG ռձ = 6500/10000 = 65%
}


//*********************************************************************
// 	: TCA5_Start()
// 	: TCA5ʱ
// ע		: 
//*********************************************************************
void TCA5_Start(){
	
	TA5CR_TAS = 1;                      	  // TCA5ʱ
	
}


//*********************************************************************
// 	: TCA5_Stop()
// 	: ֹͣTCA5ʱ
// ע		: 
//*********************************************************************
void TCA5_Stop(){
	
	TA5CR_TAS = 0;                      	  // ֹͣTCA5ʱ
	
}



//*********************************************************************
//    : TCA5_SetDuty
//  : TCA5ֵ
// ע     : 
//*********************************************************************
void TCA5_SetDuty(unsigned int duty)
{
    TA5DRB          = duty;
}



//*********************************************************************
//    : TCA5_SetPeriod
//   : TCA5ڼֵ
// ע     : 
//*********************************************************************
void TCA5_SetPeriod(unsigned int period)
{
    TA5DRA          = period;
}



//*********************************************************************
// 	: __interrupt IntTCA0()
// 	: TCA0 жӳ
// ע		:
//*********************************************************************
void __interrupt IntTCA0(void){
	__asm("NOP");							  // ָ

	TCA0_Int_Flag = 1;						  // TCA0жϷ趨Ϊ1
}



//*********************************************************************
// 	: __interrupt IntTCA1()
// 	: TCA1 жӳ
// ע		:
//*********************************************************************
void __interrupt IntTCA1(void){
	__asm("NOP");							  // ָ

	TCA1_Int_Flag = 1;						  // TCA1жϷ趨Ϊ1
	captch_count = TCA1_ReadSingleCapture();  // ȡTCA1ץȡֵ
	
}


//*********************************************************************
// 	: __interrupt IntTCA5()
// 	: TCA5 жӳ
// ע		:
//*********************************************************************
void __interrupt IntTCA5(void){
	__asm("NOP");							  // ָ

	//TCA5_Int_Flag = 1;					  // TCA5жϷ趨Ϊ1
}



